## filament 1.9.25%2Bdfsg2

=== libs/ibl/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19)
project(cmgen)

set(TARGET ibl)
set(PUBLIC_HDR_DIR include)

# ==================================================================================================
# Sources and headers
# ==================================================================================================
set(PUBLIC_HDRS
    ${PUBLIC_HDR_DIR}/ibl/Cubemap.h
    ${PUBLIC_HDR_DIR}/ibl/CubemapIBL.h
    ${PUBLIC_HDR_DIR}/ibl/CubemapSH.h
    ${PUBLIC_HDR_DIR}/ibl/CubemapUtils.h
    ${PUBLIC_HDR_DIR}/ibl/Image.h
    ${PUBLIC_HDR_DIR}/ibl/utilities.h
)

set(PRIVATE_HDRS
    src/CubemapUtilsImpl.h
)

set(SRCS
    src/Cubemap.cpp
    src/CubemapIBL.cpp
    src/CubemapSH.cpp
    src/CubemapUtils.cpp
    src/Image.cpp
)

# ==================================================================================================
# Target definitions
# ==================================================================================================
include_directories(${PUBLIC_HDR_DIR})

add_library(${TARGET} ${PUBLIC_HDRS} ${PRIVATE_HDRS} ${SRCS})
target_include_directories(${TARGET} PUBLIC ${PUBLIC_HDR_DIR})
target_link_libraries(${TARGET} math utils)

add_library(${TARGET}-lite ${PUBLIC_HDRS} ${PRIVATE_HDRS} ${SRCS})
target_compile_definitions(${TARGET}-lite PUBLIC -DFILAMENT_IBL_LITE=1)
target_include_directories(${TARGET}-lite PUBLIC ${PUBLIC_HDR_DIR})
target_link_libraries(${TARGET}-lite math utils)

# ==================================================================================================
# Compile options and optimizations
# ==================================================================================================
if (MSVC)
    target_compile_options(${TARGET} PRIVATE /fp:fast)
    target_compile_options(${TARGET}-lite PRIVATE /fp:fast)
else()
    target_compile_options(${TARGET} PRIVATE -ffast-math)
    target_compile_options(${TARGET}-lite PRIVATE -ffast-math)
endif()


# ==================================================================================================
# Installation
# ==================================================================================================
install(TARGETS ${TARGET} ARCHIVE DESTINATION lib/${DIST_DIR})
install(TARGETS ${TARGET}-lite ARCHIVE DESTINATION lib/${DIST_DIR})
install(DIRECTORY ${PUBLIC_HDR_DIR}/ibl DESTINATION include)

=== libs/image/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19)
project(image)

set(TARGET image)
set(PUBLIC_HDR_DIR include)

# ==================================================================================================
# Sources and headers
# ==================================================================================================
set(PUBLIC_HDRS
        include/image/ColorTransform.h
        include/image/ImageOps.h
        include/image/ImageSampler.h
        include/image/KtxBundle.h
        include/image/KtxUtility.h
        include/image/LinearImage.h
)

set(SRCS
        src/ImageOps.cpp
        src/ImageSampler.cpp
        src/KtxBundle.cpp
        src/LinearImage.cpp
)

# ==================================================================================================
# Include and target definitions
# ==================================================================================================
include_directories(${PUBLIC_HDR_DIR})

add_library(${TARGET} STATIC ${PUBLIC_HDRS} ${SRCS})

target_link_libraries(${TARGET} PUBLIC math utils)

target_include_directories(${TARGET} PUBLIC ${PUBLIC_HDR_DIR})

# ==================================================================================================
# Compiler flags
# ==================================================================================================
if (MSVC)
    target_compile_options(${TARGET} PRIVATE $<$<CONFIG:Release>:/fp:fast>)
else()
    target_compile_options(${TARGET} PRIVATE $<$<CONFIG:Release>:-ffast-math>)
    target_compile_options(${TARGET} PRIVATE -Wno-deprecated-register)
endif()

# ==================================================================================================
# Expose header-only utilities to lean-and-mean client projects.
# ==================================================================================================
add_library(image_headers INTERFACE)
target_include_directories(image_headers INTERFACE ${PUBLIC_HDR_DIR})

# ==================================================================================================
# Installation
# ==================================================================================================
install(TARGETS ${TARGET} ARCHIVE DESTINATION lib/${DIST_DIR})
install(DIRECTORY ${PUBLIC_HDR_DIR}/image DESTINATION include)

# ==================================================================================================
# Tests
# ==================================================================================================
if (NOT ANDROID AND NOT WEBGL AND NOT IOS)
    add_executable(test_${TARGET} tests/test_image.cpp)
    target_link_libraries(test_${TARGET} PRIVATE image imageio gtest)
endif()

=== libs/utils/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19)
project(utils)

set(TARGET utils)
set(TARGET_LINUX ${TARGET}/linux)
set(TARGET_GENERIC ${TARGET}/generic)
set(PUBLIC_HDR_DIR include)

# ==================================================================================================
# Sources and headers
# ==================================================================================================
file(GLOB_RECURSE PUBLIC_HDRS ${PUBLIC_HDR_DIR}/${TARGET}/*.h)

set(DIST_HDRS
        ${PUBLIC_HDR_DIR}/${TARGET}/algorithm.h
        ${PUBLIC_HDR_DIR}/${TARGET}/bitset.h
        ${PUBLIC_HDR_DIR}/${TARGET}/debug.h
        ${PUBLIC_HDR_DIR}/${TARGET}/Allocator.h
        ${PUBLIC_HDR_DIR}/${TARGET}/BitmaskEnum.h
        ${PUBLIC_HDR_DIR}/${TARGET}/compiler.h
        ${PUBLIC_HDR_DIR}/${TARGET}/CString.h
        ${PUBLIC_HDR_DIR}/${TARGET}/Entity.h
        ${PUBLIC_HDR_DIR}/${TARGET}/EntityInstance.h
        ${PUBLIC_HDR_DIR}/${TARGET}/EntityManager.h
        ${PUBLIC_HDR_DIR}/${TARGET}/Log.h
        ${PUBLIC_HDR_DIR}/${TARGET}/memalign.h
        ${PUBLIC_HDR_DIR}/${TARGET}/Mutex.h
        ${PUBLIC_HDR_DIR}/${TARGET}/NameComponentManager.h
        ${PUBLIC_HDR_DIR}/${TARGET}/ostream.h
        ${PUBLIC_HDR_DIR}/${TARGET}/Path.h
        ${PUBLIC_HDR_DIR}/${TARGET}/SingleInstanceComponentManager.h
        ${PUBLIC_HDR_DIR}/${TARGET}/Slice.h
        ${PUBLIC_HDR_DIR}/${TARGET}/SpinLock.h
        ${PUBLIC_HDR_DIR}/${TARGET}/StructureOfArrays.h
        ${PUBLIC_HDR_DIR}/${TARGET}/ThreadLocal.h
        ${PUBLIC_HDR_DIR}/${TARGET}/unwindows.h
)

set(DIST_LINUX_HDRS
        ${PUBLIC_HDR_DIR}/${TARGET_LINUX}/Mutex.h
)

set(DIST_GENERIC_HDRS
        ${PUBLIC_HDR_DIR}/${TARGET_GENERIC}/Mutex.h
)

set(SRCS
        src/api_level.cpp
        src/ashmem.cpp
        src/debug.cpp
        src/Allocator.cpp
        src/CallStack.cpp
        src/CString.cpp
        src/CountDownLatch.cpp
        src/CyclicBarrier.cpp
        src/EntityManager.cpp
        src/EntityManagerImpl.h
        src/JobSystem.cpp
        src/Log.cpp
        src/NameComponentManager.cpp
        src/ostream.cpp
        src/Panic.cpp
        src/Path.cpp
        src/Profiler.cpp
        src/sstream.cpp
        src/Systrace.cpp
)

if (WIN32)
    list(APPEND SRCS src/win32/Path.cpp)
endif()
if (LINUX OR ANDROID)
    list(APPEND SRCS src/linux/Condition.cpp)
    list(APPEND SRCS src/linux/Mutex.cpp)
    list(APPEND SRCS src/linux/Path.cpp)
endif()
if (APPLE)
    list(APPEND SRCS src/darwin/Path.mm)
endif()

# ==================================================================================================
# Includes and target definition
# ==================================================================================================
include_directories(${PUBLIC_HDR_DIR})

add_library(${TARGET} STATIC ${PUBLIC_HDRS} ${SRCS})
target_include_directories(${TARGET} PUBLIC ${PUBLIC_HDR_DIR})
target_link_libraries(${TARGET} PUBLIC tsl)

if (ANDROID)
    target_link_libraries(${TARGET} PUBLIC log)
    target_link_libraries(${TARGET} PRIVATE dl)
endif()

if (WIN32)
    # Needed for shlwapi.h (GetModuleFileName)
    target_link_libraries(${TARGET} PUBLIC Shlwapi)
endif()

if (LINUX)
    set(THREADS_PREFER_PTHREAD_FLAG ON)
    find_package(Threads REQUIRED)
    target_link_libraries(${TARGET} PRIVATE Threads::Threads)
    target_link_libraries(${TARGET} PRIVATE dl)
endif()

# ==================================================================================================
# Compiler flags
# ==================================================================================================
target_compile_options(${TARGET} PRIVATE
# TODO: use hidden by default and expose what we need
#        -fvisibility=hidden
#        -fvisibility-inlines-hidden
)

# ==================================================================================================
# Installation
# ==================================================================================================
set(INSTALL_TYPE ARCHIVE)
install(TARGETS ${TARGET} ${INSTALL_TYPE} DESTINATION lib/${DIST_DIR})
install(FILES ${DIST_HDRS} DESTINATION include/${TARGET})
if (LINUX OR ANDROID)
    install(FILES ${DIST_LINUX_HDRS} DESTINATION include/${TARGET_LINUX})
else()
    install(FILES ${DIST_GENERIC_HDRS} DESTINATION include/${TARGET_GENERIC})
endif()

# ==================================================================================================
# Test executables
# ==================================================================================================

set(TEST_SRCS
        test/test_algorithm.cpp
        test/test_Allocators.cpp
        test/test_bitset.cpp
        test/test_CountDownLatch.cpp
        test/test_CString.cpp
        test/test_CyclicBarrier.cpp
        test/test_Entity.cpp
        test/test_JobSystem.cpp
        test/test_StructureOfArrays.cpp
        test/test_sstream.cpp
        test/test_utils_main.cpp
        test/test_Zip2Iterator.cpp
        test/test_BinaryTreeArray.cpp
)

# The Path tests are platform-specific
if (NOT WEBGL)
    if (WIN32)
        list(APPEND TEST_SRCS test/test_WinPath.cpp)
    else()
        list(APPEND TEST_SRCS test/test_Path.cpp)
    endif()
endif()

add_executable(test_${TARGET} ${TEST_SRCS})

target_link_libraries(test_${TARGET} PRIVATE gtest utils tsl math)

# ==================================================================================================
# Benchmarks
# ==================================================================================================

if (NOT WEBGL)

    add_library(benchmark_${TARGET}_callee SHARED benchmark/benchmark_callee.cpp)

    set(BENCHMARK_SRCS
            benchmark/benchmark_allocators.cpp
            benchmark/benchmark_binary_search.cpp
            benchmark/benchmark_calls.cpp
            benchmark/benchmark_JobSystem.cpp
            benchmark/benchmark_mutex.cpp
            benchmark/benchmark_memcpy.cpp)


    add_executable(benchmark_${TARGET} ${BENCHMARK_SRCS})

    target_link_libraries(benchmark_${TARGET} PRIVATE benchmark_main utils benchmark_${TARGET}_callee)

endif()

=== tools/matinfo/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19)
project(matinfo)

set(TARGET matinfo)

# ==================================================================================================
# Sources and headers
# ==================================================================================================
set(SRCS src/main.cpp)

# ==================================================================================================
# Target definitions
# ==================================================================================================
add_executable(${TARGET} ${SRCS})

target_link_libraries(${TARGET} matdbg filaflat backend_headers utils getopt SPIRV-Tools spirv-cross-glsl)

# glslang contains a copy of the SPIRV headers, so let's just use those. The leading ".." in the
# following variable refers to the project name that we define in glslang/tnt, and the trailing ".."
# in the path allows us to do #include <SPIRV/disassemble.h>
target_include_directories(${TARGET} PRIVATE ${../glslang_SOURCE_DIR}/..)

# =================================================================================================
# Licenses
# ==================================================================================================
set(MODULE_LICENSES getopt glslang smol-v)
set(GENERATION_ROOT ${CMAKE_CURRENT_BINARY_DIR}/generated)
list_licenses(${GENERATION_ROOT}/licenses/licenses.inc ${MODULE_LICENSES})
target_include_directories(${TARGET} PRIVATE ${GENERATION_ROOT})

# ==================================================================================================
# Installation
# ==================================================================================================
install(TARGETS ${TARGET} RUNTIME DESTINATION bin)
install(FILES "README.md" DESTINATION docs/ RENAME "${TARGET}.md")

=== third_party/vkmemalloc/tnt/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19)
project(vkmemalloc)

set(TARGET vkmemalloc)

set(PUBLIC_HDR_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../src)

set(PUBLIC_HDRS ${PUBLIC_HDR_DIR}/vk_mem_alloc.h)

include_directories(${PUBLIC_HDR_DIR})

add_library(${TARGET} INTERFACE)
target_sources(${TARGET} INTERFACE ${PUBLIC_HDRS})
target_include_directories(${TARGET} INTERFACE ${PUBLIC_HDR_DIR})

=== debian/control ===
Source: filament
Section: libs
Priority: optional
Maintainer: Timo Röhling <roehling@debian.org>
Build-Depends: debhelper-compat (= 13),
    clang,
    cmake,
    glslang-dev (>= 11.12.0),
    libassimp-dev,
    libastcenc-dev,
    libbenchmark-dev,
    libdraco-dev,
    libepoxy-dev,
    libgtest-dev,
    libimgui-dev,
    libjsmn-dev,
    libmeshoptimizer-dev,
    libpng-dev,
    libsdl2-dev,
    libstb-dev,
    libtinyexr-dev,
    libspirv-cross-c-shared-dev (>= 2021.01.15-5~),
    robin-map-dev,
    spirv-tools,
    zlib1g-dev,
Homepage: https://github.com/google/filament
Standards-Version: 4.6.2
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/roehling/filament.git
Vcs-Browser: https://salsa.debian.org/roehling/filament

Package: libfilament1.9
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Real-time physically based rendering engine
 Physically based rendering is a rendering method that provides a more
 accurate representation of materials and how they interact with light
 when compared to traditional real-time models.

Package: libfilament-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         libfilament1.9 (= ${binary:Version}),
         libimgui-dev,
         libstb-dev,
         robin-map-dev,
Recommends: libfilament-tools (= ${binary:Version})
Description: Real-time physically based rendering engine - development headers
 Physically based rendering is a rendering method that provides a more
 accurate representation of materials and how they interact with light
 when compared to traditional real-time models.
 .
 This package installs the development headers.

Package: libfilament-tools
Section: devel
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Real-time physically based rendering engine - command-line tools
 Physically based rendering is a rendering method that provides a more
 accurate representation of materials and how they interact with light
 when compared to traditional real-time models.
 .
 This package installs the command-line tools for material preprocessing.
